// **********************************************************************
//
// Copyright (c) 2003-2004 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.0.0
// Generated from file `flowengine.ice'

using _System = System;
using _Microsoft = Microsoft;

namespace FlowEngine
{
    public class AbstractActionPrxList : _System.Collections.CollectionBase, _System.ICloneable
    {
	#region Constructors

	public AbstractActionPrxList()
	{
	}

	public AbstractActionPrxList(int capacity)
	{
	    InnerList.Capacity = capacity;
	}

	public AbstractActionPrxList(FlowEngine.AbstractActionPrx[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region Array copy and conversion

	public void CopyTo(FlowEngine.AbstractActionPrx[] __a)
	{
	    InnerList.CopyTo(__a);
	}

	public void CopyTo(FlowEngine.AbstractActionPrx[] __a, int __i)
	{
	    InnerList.CopyTo(__a, __i);
	}

	public void CopyTo(int __i, FlowEngine.AbstractActionPrx[] __a, int __ai, int __c)
	{
	    InnerList.CopyTo(__i, __a, __ai, __c);
	}

	public FlowEngine.AbstractActionPrx[] ToArray()
	{
	    FlowEngine.AbstractActionPrx[] __a = new FlowEngine.AbstractActionPrx[InnerList.Count];
	    InnerList.CopyTo(__a, 0);
	    return __a;
	}

	#endregion

	#region AddRange members

	public void AddRange(AbstractActionPrxList __s)
	{
	    InnerList.AddRange(__s);
	}

	public void AddRange(FlowEngine.AbstractActionPrx[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region ICollectionBase members

	public int Add(FlowEngine.AbstractActionPrx value)
	{
	    return InnerList.Add(value);
	}

	public int IndexOf(FlowEngine.AbstractActionPrx value)
	{
	    return InnerList.IndexOf(value);
	}

	public void Insert(int index, FlowEngine.AbstractActionPrx value)
	{
	    InnerList.Insert(index, value);
	}

	public void Remove(FlowEngine.AbstractActionPrx value)
	{
	    InnerList.Remove(value);
	}

	public bool Contains(FlowEngine.AbstractActionPrx value)
	{
	    return InnerList.Contains(value);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region IList members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	#region Indexer

	public FlowEngine.AbstractActionPrx this[int index]
	{
	    get
	    {
		return (FlowEngine.AbstractActionPrx)InnerList[index];
	    }
	    set
	    {
		InnerList[index] = value;
	    }
	}

	#endregion

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    for(int i = 0; i < Count; ++i)
	    {
		if((object)InnerList[i] != null)
		{
		    hash = 5 * hash + InnerList[i].GetHashCode();
		}
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is AbstractActionPrxList))
	    {
		return false;
	    }
	    if(Count != ((AbstractActionPrxList)other).Count)
	    {
		return false;
	    }
	    for(int __i = 0; __i < Count; ++__i)
	    {
		if(InnerList[__i] == null && ((AbstractActionPrxList)other)[__i] != null)
		{
		    return false;
		}
		if(!((FlowEngine.AbstractActionPrx)(InnerList[__i])).Equals(((AbstractActionPrxList)other)[__i]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(AbstractActionPrxList __lhs, AbstractActionPrxList __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(AbstractActionPrxList __lhs, AbstractActionPrxList __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(AbstractActionPrxList __lhs, AbstractActionPrxList __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion
    }

    public class IntMap : _System.Collections.DictionaryBase, _System.ICloneable
    {
	#region IntMap members

	public void AddRange(IntMap __d)
	{
	    foreach(_System.Collections.DictionaryEntry e in __d)
	    {
		try
		{
		    InnerHashtable.Add(e.Key, e.Value);
		}
		catch(_System.ArgumentException)
		{
		    // ignore
		}
	    }
	}

	#endregion

	#region IDictionary members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	public _System.Collections.ICollection Keys
	{
	    get
	    {
		return InnerHashtable.Keys;
	    }
	}

	public _System.Collections.ICollection Values
	{
	    get
	    {
		return InnerHashtable.Values;
	    }
	}

	#region Indexer

	public int this[int key]
	{
	    get
	    {
		return (int)InnerHashtable[key];
	    }
	    set
	    {
		InnerHashtable[key] = value;
	    }
	}

	#endregion

	public void Add(int key, int value)
	{
	    InnerHashtable.Add(key, value);
	}

	public void Remove(int key)
	{
	    InnerHashtable.Remove(key);
	}

	public bool Contains(int key)
	{
	    return InnerHashtable.Contains(key);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    foreach(_System.Collections.DictionaryEntry e in InnerHashtable)
	    {
		hash = 5 * hash + e.Key.GetHashCode();
		hash = 5 * hash + e.Value.GetHashCode();
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is IntMap))
	    {
		return false;
	    }
	    if(Count != ((IntMap)other).Count)
	    {
		return false;
	    }
	    int[] __klhs = new int[Count];
	    Keys.CopyTo(__klhs, 0);
	    _System.Array.Sort(__klhs);
	    int[] __krhs = new int[((IntMap)other).Count];
	    ((IntMap)other).Keys.CopyTo(__krhs, 0);
	    _System.Array.Sort(__krhs);
	    for(int i = 0; i < Count; ++i)
	    {
		if(!__klhs[i].Equals(__krhs[i]))
		{
		    return false;
		}
	    }
	    int[] __vlhs = new int[Count];
	    Values.CopyTo(__vlhs, 0);
	    _System.Array.Sort(__vlhs);
	    int[] __vrhs = new int[((IntMap)other).Count];
	    ((IntMap)other).Values.CopyTo(__vrhs, 0);
	    _System.Array.Sort(__vrhs);
	    for(int i = 0; i < Count; ++i)
	    {
		if(!__vlhs[i].Equals(__vrhs[i]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(IntMap __lhs, IntMap __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(IntMap __lhs, IntMap __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(IntMap __lhs, IntMap __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion
    }

    public interface AbstractAction : Ice.Object, _AbstractActionOperations, _AbstractActionOperationsNC
    {
    }

    public interface AbstractActionFactory : Ice.Object, _AbstractActionFactoryOperations, _AbstractActionFactoryOperationsNC
    {
    }

    public interface Process : Ice.Object, _ProcessOperations, _ProcessOperationsNC
    {
    }

    public interface ProcessFactory : Ice.Object, _ProcessFactoryOperations, _ProcessFactoryOperationsNC
    {
    }
}

namespace FlowEngine
{
    public interface AbstractActionPrx : Ice.ObjectPrx
    {
	string describe();
	string describe(Ice.Context __context);

	void setOptions(Global.KeyValueList options);
	void setOptions(Global.KeyValueList options, Ice.Context __context);

	int getId();
	int getId(Ice.Context __context);

	void setId(int id);
	void setId(int id, Ice.Context __context);

	void perform();
	void perform(Ice.Context __context);

	void perform_async(AMI_AbstractAction_perform __cb);
	void perform_async(AMI_AbstractAction_perform __cb, Ice.Context __ctx);

	bool done();
	bool done(Ice.Context __context);
    }

    public interface AbstractActionFactoryPrx : Ice.ObjectPrx
    {
	FlowEngine.AbstractActionPrx createAction();
	FlowEngine.AbstractActionPrx createAction(Ice.Context __context);

	string describe();
	string describe(Ice.Context __context);
    }

    public interface ProcessPrx : Ice.ObjectPrx
    {
	FlowEngine.AbstractActionPrxList enumActions();
	FlowEngine.AbstractActionPrxList enumActions(Ice.Context __context);

	FlowEngine.AbstractActionPrxList enumStartActions();
	FlowEngine.AbstractActionPrxList enumStartActions(Ice.Context __context);

	FlowEngine.AbstractActionPrx getCurrentAction();
	FlowEngine.AbstractActionPrx getCurrentAction(Ice.Context __context);

	FlowEngine.AbstractActionPrx findAction(int id);
	FlowEngine.AbstractActionPrx findAction(int id, Ice.Context __context);

	FlowEngine.IntMap getConnectionMap();
	FlowEngine.IntMap getConnectionMap(Ice.Context __context);

	int addAction(FlowEngine.AbstractActionPrx action);
	int addAction(FlowEngine.AbstractActionPrx action, Ice.Context __context);

	void addActionWithId(FlowEngine.AbstractActionPrx action, int id);
	void addActionWithId(FlowEngine.AbstractActionPrx action, int id, Ice.Context __context);

	bool isActive();
	bool isActive(Ice.Context __context);

	void setEdge(int id0, int id1);
	void setEdge(int id0, int id1, Ice.Context __context);

	FlowEngine.AbstractActionPrxList getNextActionsById(int id);
	FlowEngine.AbstractActionPrxList getNextActionsById(int id, Ice.Context __context);

	FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action);
	FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action, Ice.Context __context);

	bool tempIterate();
	bool tempIterate(Ice.Context __context);
    }

    public interface ProcessFactoryPrx : Ice.ObjectPrx
    {
	FlowEngine.ProcessPrx createProcess();
	FlowEngine.ProcessPrx createProcess(Ice.Context __context);
    }
}

namespace FlowEngine
{
    public interface _AbstractActionOperations
    {
	string describe(Ice.Current __current);

	void setOptions(Global.KeyValueList options, Ice.Current __current);

	int getId(Ice.Current __current);

	void setId(int id, Ice.Current __current);

	void perform(Ice.Current __current);

	bool done(Ice.Current __current);
    }

    public interface _AbstractActionOperationsNC
    {
	string describe();

	void setOptions(Global.KeyValueList options);

	int getId();

	void setId(int id);

	void perform();

	bool done();
    }

    public interface _AbstractActionFactoryOperations
    {
	FlowEngine.AbstractActionPrx createAction(Ice.Current __current);

	string describe(Ice.Current __current);
    }

    public interface _AbstractActionFactoryOperationsNC
    {
	FlowEngine.AbstractActionPrx createAction();

	string describe();
    }

    public interface _ProcessOperations
    {
	FlowEngine.AbstractActionPrxList enumActions(Ice.Current __current);

	FlowEngine.AbstractActionPrxList enumStartActions(Ice.Current __current);

	FlowEngine.AbstractActionPrx getCurrentAction(Ice.Current __current);

	FlowEngine.AbstractActionPrx findAction(int id, Ice.Current __current);

	FlowEngine.IntMap getConnectionMap(Ice.Current __current);

	int addAction(FlowEngine.AbstractActionPrx action, Ice.Current __current);

	void addActionWithId(FlowEngine.AbstractActionPrx action, int id, Ice.Current __current);

	bool isActive(Ice.Current __current);

	void setEdge(int id0, int id1, Ice.Current __current);

	FlowEngine.AbstractActionPrxList getNextActionsById(int id, Ice.Current __current);

	FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action, Ice.Current __current);

	bool tempIterate(Ice.Current __current);
    }

    public interface _ProcessOperationsNC
    {
	FlowEngine.AbstractActionPrxList enumActions();

	FlowEngine.AbstractActionPrxList enumStartActions();

	FlowEngine.AbstractActionPrx getCurrentAction();

	FlowEngine.AbstractActionPrx findAction(int id);

	FlowEngine.IntMap getConnectionMap();

	int addAction(FlowEngine.AbstractActionPrx action);

	void addActionWithId(FlowEngine.AbstractActionPrx action, int id);

	bool isActive();

	void setEdge(int id0, int id1);

	FlowEngine.AbstractActionPrxList getNextActionsById(int id);

	FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action);

	bool tempIterate();
    }

    public interface _ProcessFactoryOperations
    {
	FlowEngine.ProcessPrx createProcess(Ice.Current __current);
    }

    public interface _ProcessFactoryOperationsNC
    {
	FlowEngine.ProcessPrx createProcess();
    }
}

namespace FlowEngine
{
    public sealed class AbstractActionPrxListHelper
    {
	public static void write(IceInternal.BasicStream __os, FlowEngine.AbstractActionPrxList __v)
	{
	    if(__v == null)
	    {
		__os.writeSize(0);
	    }
	    else
	    {
		__os.writeSize(__v.Count);
		for(int __ix = 0; __ix < __v.Count; ++__ix)
		{
		    FlowEngine.AbstractActionPrxHelper.__write(__os, __v[__ix]);
		}
	    }
	}

	public static FlowEngine.AbstractActionPrxList read(IceInternal.BasicStream __is)
	{
	    FlowEngine.AbstractActionPrxList __v;
	    {
		int szx = __is.readSize();
		__is.startSeq(szx, 2);
		__v = new FlowEngine.AbstractActionPrxList(szx);
		for(int __ix = 0; __ix < szx; ++__ix)
		{
		    __v.Add(FlowEngine.AbstractActionPrxHelper.__read(__is));
		    __is.checkSeq();
		    __is.endElement();
		}
		__is.endSeq(szx);
	    }
	    return __v;
	}
    }

    public sealed class IntMapHelper
    {
	public static void write(IceInternal.BasicStream __os, IntMap __v)
	{
	    if(__v == null)
	    {
		__os.writeSize(0);
	    }
	    else
	    {
		__os.writeSize(__v.Count);
		foreach(_System.Collections.DictionaryEntry __e in __v)
		{
		    __os.writeInt(((int)__e.Key));
		    __os.writeInt(((int)__e.Value));
		}
	    }
	}

	public static IntMap read(IceInternal.BasicStream __is)
	{
	    int __sz = __is.readSize();
	    IntMap __r = new IntMap();
	    for(int __i = 0; __i < __sz; ++__i)
	    {
		int __k;
		__k = __is.readInt();
		int __v;
		__v = __is.readInt();
		__r[__k] = __v;
	    }
	    return __r;
	}
    }

    public sealed class AbstractActionPrxHelper : Ice.ObjectPrxHelperBase, AbstractActionPrx
    {
	#region Synchronous operations

	public string describe()
	{
	    return describe(__defaultContext());
	}

	public string describe(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("describe");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AbstractActionDel __del = (_AbstractActionDel)__delBase;
		    return __del.describe(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public bool done()
	{
	    return done(__defaultContext());
	}

	public bool done(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("done");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AbstractActionDel __del = (_AbstractActionDel)__delBase;
		    return __del.done(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public int getId()
	{
	    return getId(__defaultContext());
	}

	public int getId(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getId");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AbstractActionDel __del = (_AbstractActionDel)__delBase;
		    return __del.getId(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void perform()
	{
	    perform(__defaultContext());
	}

	public void perform(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AbstractActionDel __del = (_AbstractActionDel)__delBase;
		    __del.perform(__context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void setId(int id)
	{
	    setId(id, __defaultContext());
	}

	public void setId(int id, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AbstractActionDel __del = (_AbstractActionDel)__delBase;
		    __del.setId(id, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void setOptions(Global.KeyValueList options)
	{
	    setOptions(options, __defaultContext());
	}

	public void setOptions(Global.KeyValueList options, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AbstractActionDel __del = (_AbstractActionDel)__delBase;
		    __del.setOptions(options, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	#endregion

	#region Asynchronous operations

	public void perform_async(AMI_AbstractAction_perform __cb)
	{
	    perform_async(__cb, __defaultContext());
	}
	public void perform_async(AMI_AbstractAction_perform __cb, Ice.Context __ctx)
	{
	    __checkTwowayOnly("AbstractAction");
	    __cb.__invoke(this, __cb, __ctx);
	}

	#endregion

	#region Checked and unchecked cast operations

	public static AbstractActionPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is AbstractActionPrx)
	    {
		return (AbstractActionPrx)b;
	    }
	    if(b.ice_isA("::FlowEngine::AbstractAction"))
	    {
		AbstractActionPrxHelper h = new AbstractActionPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static AbstractActionPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::FlowEngine::AbstractAction"))
		{
		    AbstractActionPrxHelper h = new AbstractActionPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static AbstractActionPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    AbstractActionPrxHelper h = new AbstractActionPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static AbstractActionPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    AbstractActionPrxHelper h = new AbstractActionPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _AbstractActionDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _AbstractActionDelD();
	}

	public static void __write(IceInternal.BasicStream __os, AbstractActionPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static AbstractActionPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		AbstractActionPrxHelper result = new AbstractActionPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public sealed class AbstractActionFactoryPrxHelper : Ice.ObjectPrxHelperBase, AbstractActionFactoryPrx
    {
	#region Synchronous operations

	public FlowEngine.AbstractActionPrx createAction()
	{
	    return createAction(__defaultContext());
	}

	public FlowEngine.AbstractActionPrx createAction(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("createAction");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AbstractActionFactoryDel __del = (_AbstractActionFactoryDel)__delBase;
		    return __del.createAction(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public string describe()
	{
	    return describe(__defaultContext());
	}

	public string describe(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("describe");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AbstractActionFactoryDel __del = (_AbstractActionFactoryDel)__delBase;
		    return __del.describe(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	#endregion

	#region Checked and unchecked cast operations

	public static AbstractActionFactoryPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is AbstractActionFactoryPrx)
	    {
		return (AbstractActionFactoryPrx)b;
	    }
	    if(b.ice_isA("::FlowEngine::AbstractActionFactory"))
	    {
		AbstractActionFactoryPrxHelper h = new AbstractActionFactoryPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static AbstractActionFactoryPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::FlowEngine::AbstractActionFactory"))
		{
		    AbstractActionFactoryPrxHelper h = new AbstractActionFactoryPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static AbstractActionFactoryPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    AbstractActionFactoryPrxHelper h = new AbstractActionFactoryPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static AbstractActionFactoryPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    AbstractActionFactoryPrxHelper h = new AbstractActionFactoryPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _AbstractActionFactoryDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _AbstractActionFactoryDelD();
	}

	public static void __write(IceInternal.BasicStream __os, AbstractActionFactoryPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static AbstractActionFactoryPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		AbstractActionFactoryPrxHelper result = new AbstractActionFactoryPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public sealed class ProcessPrxHelper : Ice.ObjectPrxHelperBase, ProcessPrx
    {
	#region Synchronous operations

	public int addAction(FlowEngine.AbstractActionPrx action)
	{
	    return addAction(action, __defaultContext());
	}

	public int addAction(FlowEngine.AbstractActionPrx action, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("addAction");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    return __del.addAction(action, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void addActionWithId(FlowEngine.AbstractActionPrx action, int id)
	{
	    addActionWithId(action, id, __defaultContext());
	}

	public void addActionWithId(FlowEngine.AbstractActionPrx action, int id, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    __del.addActionWithId(action, id, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public FlowEngine.AbstractActionPrxList enumActions()
	{
	    return enumActions(__defaultContext());
	}

	public FlowEngine.AbstractActionPrxList enumActions(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("enumActions");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    return __del.enumActions(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public FlowEngine.AbstractActionPrxList enumStartActions()
	{
	    return enumStartActions(__defaultContext());
	}

	public FlowEngine.AbstractActionPrxList enumStartActions(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("enumStartActions");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    return __del.enumStartActions(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public FlowEngine.AbstractActionPrx findAction(int id)
	{
	    return findAction(id, __defaultContext());
	}

	public FlowEngine.AbstractActionPrx findAction(int id, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("findAction");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    return __del.findAction(id, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public FlowEngine.IntMap getConnectionMap()
	{
	    return getConnectionMap(__defaultContext());
	}

	public FlowEngine.IntMap getConnectionMap(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getConnectionMap");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    return __del.getConnectionMap(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public FlowEngine.AbstractActionPrx getCurrentAction()
	{
	    return getCurrentAction(__defaultContext());
	}

	public FlowEngine.AbstractActionPrx getCurrentAction(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getCurrentAction");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    return __del.getCurrentAction(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action)
	{
	    return getNextActions(action, __defaultContext());
	}

	public FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getNextActions");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    return __del.getNextActions(action, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public FlowEngine.AbstractActionPrxList getNextActionsById(int id)
	{
	    return getNextActionsById(id, __defaultContext());
	}

	public FlowEngine.AbstractActionPrxList getNextActionsById(int id, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getNextActionsById");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    return __del.getNextActionsById(id, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public bool isActive()
	{
	    return isActive(__defaultContext());
	}

	public bool isActive(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("isActive");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    return __del.isActive(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void setEdge(int id0, int id1)
	{
	    setEdge(id0, id1, __defaultContext());
	}

	public void setEdge(int id0, int id1, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    __del.setEdge(id0, id1, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public bool tempIterate()
	{
	    return tempIterate(__defaultContext());
	}

	public bool tempIterate(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("tempIterate");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessDel __del = (_ProcessDel)__delBase;
		    return __del.tempIterate(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	#endregion

	#region Checked and unchecked cast operations

	public static ProcessPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is ProcessPrx)
	    {
		return (ProcessPrx)b;
	    }
	    if(b.ice_isA("::FlowEngine::Process"))
	    {
		ProcessPrxHelper h = new ProcessPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static ProcessPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::FlowEngine::Process"))
		{
		    ProcessPrxHelper h = new ProcessPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static ProcessPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    ProcessPrxHelper h = new ProcessPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static ProcessPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    ProcessPrxHelper h = new ProcessPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _ProcessDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _ProcessDelD();
	}

	public static void __write(IceInternal.BasicStream __os, ProcessPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static ProcessPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		ProcessPrxHelper result = new ProcessPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public sealed class ProcessFactoryPrxHelper : Ice.ObjectPrxHelperBase, ProcessFactoryPrx
    {
	#region Synchronous operations

	public FlowEngine.ProcessPrx createProcess()
	{
	    return createProcess(__defaultContext());
	}

	public FlowEngine.ProcessPrx createProcess(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("createProcess");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ProcessFactoryDel __del = (_ProcessFactoryDel)__delBase;
		    return __del.createProcess(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	#endregion

	#region Checked and unchecked cast operations

	public static ProcessFactoryPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is ProcessFactoryPrx)
	    {
		return (ProcessFactoryPrx)b;
	    }
	    if(b.ice_isA("::FlowEngine::ProcessFactory"))
	    {
		ProcessFactoryPrxHelper h = new ProcessFactoryPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static ProcessFactoryPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::FlowEngine::ProcessFactory"))
		{
		    ProcessFactoryPrxHelper h = new ProcessFactoryPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static ProcessFactoryPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    ProcessFactoryPrxHelper h = new ProcessFactoryPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static ProcessFactoryPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    ProcessFactoryPrxHelper h = new ProcessFactoryPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _ProcessFactoryDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _ProcessFactoryDelD();
	}

	public static void __write(IceInternal.BasicStream __os, ProcessFactoryPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static ProcessFactoryPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		ProcessFactoryPrxHelper result = new ProcessFactoryPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }
}

namespace FlowEngine
{
    public interface _AbstractActionDel : Ice._ObjectDel
    {
	string describe(Ice.Context __context);

	void setOptions(Global.KeyValueList options, Ice.Context __context);

	int getId(Ice.Context __context);

	void setId(int id, Ice.Context __context);

	void perform(Ice.Context __context);

	bool done(Ice.Context __context);
    }

    public interface _AbstractActionFactoryDel : Ice._ObjectDel
    {
	FlowEngine.AbstractActionPrx createAction(Ice.Context __context);

	string describe(Ice.Context __context);
    }

    public interface _ProcessDel : Ice._ObjectDel
    {
	FlowEngine.AbstractActionPrxList enumActions(Ice.Context __context);

	FlowEngine.AbstractActionPrxList enumStartActions(Ice.Context __context);

	FlowEngine.AbstractActionPrx getCurrentAction(Ice.Context __context);

	FlowEngine.AbstractActionPrx findAction(int id, Ice.Context __context);

	FlowEngine.IntMap getConnectionMap(Ice.Context __context);

	int addAction(FlowEngine.AbstractActionPrx action, Ice.Context __context);

	void addActionWithId(FlowEngine.AbstractActionPrx action, int id, Ice.Context __context);

	bool isActive(Ice.Context __context);

	void setEdge(int id0, int id1, Ice.Context __context);

	FlowEngine.AbstractActionPrxList getNextActionsById(int id, Ice.Context __context);

	FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action, Ice.Context __context);

	bool tempIterate(Ice.Context __context);
    }

    public interface _ProcessFactoryDel : Ice._ObjectDel
    {
	FlowEngine.ProcessPrx createProcess(Ice.Context __context);
    }
}

namespace FlowEngine
{
    public sealed class _AbstractActionDelM : Ice._ObjectDelM, _AbstractActionDel
    {
	public string describe(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("describe", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    string __ret;
		    __ret = __is.readString();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public bool done(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("done", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    bool __ret;
		    __ret = __is.readBool();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public int getId(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getId", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    int __ret;
		    __ret = __is.readInt();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void perform(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("perform", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void setId(int id, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("setId", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		try
		{
		    IceInternal.BasicStream __os = __out.ostr();
		    __os.writeInt(id);
		}
		catch(Ice.LocalException __ex)
		{
		    __out.abort(__ex);
		}
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void setOptions(Global.KeyValueList options, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("setOptions", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		try
		{
		    IceInternal.BasicStream __os = __out.ostr();
		    if(options == null)
		    {
			__os.writeSize(0);
		    }
		    else
		    {
			__os.writeSize(options.Count);
			for(int __ix = 0; __ix < options.Count; ++__ix)
			{
			    options[__ix].__write(__os);
			}
		    }
		}
		catch(Ice.LocalException __ex)
		{
		    __out.abort(__ex);
		}
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}
    }

    public sealed class _AbstractActionFactoryDelM : Ice._ObjectDelM, _AbstractActionFactoryDel
    {
	public FlowEngine.AbstractActionPrx createAction(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("createAction", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    FlowEngine.AbstractActionPrx __ret;
		    __ret = FlowEngine.AbstractActionPrxHelper.__read(__is);
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public string describe(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("describe", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    string __ret;
		    __ret = __is.readString();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}
    }

    public sealed class _ProcessDelM : Ice._ObjectDelM, _ProcessDel
    {
	public int addAction(FlowEngine.AbstractActionPrx action, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("addAction", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		try
		{
		    IceInternal.BasicStream __os = __out.ostr();
		    FlowEngine.AbstractActionPrxHelper.__write(__os, action);
		}
		catch(Ice.LocalException __ex)
		{
		    __out.abort(__ex);
		}
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    int __ret;
		    __ret = __is.readInt();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void addActionWithId(FlowEngine.AbstractActionPrx action, int id, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("addActionWithId", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		try
		{
		    IceInternal.BasicStream __os = __out.ostr();
		    FlowEngine.AbstractActionPrxHelper.__write(__os, action);
		    __os.writeInt(id);
		}
		catch(Ice.LocalException __ex)
		{
		    __out.abort(__ex);
		}
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public FlowEngine.AbstractActionPrxList enumActions(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("enumActions", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    FlowEngine.AbstractActionPrxList __ret;
		    {
			int szx = __is.readSize();
			__is.startSeq(szx, 2);
			__ret = new FlowEngine.AbstractActionPrxList(szx);
			for(int __ix = 0; __ix < szx; ++__ix)
			{
			    __ret.Add(FlowEngine.AbstractActionPrxHelper.__read(__is));
			    __is.checkSeq();
			    __is.endElement();
			}
			__is.endSeq(szx);
		    }
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public FlowEngine.AbstractActionPrxList enumStartActions(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("enumStartActions", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    FlowEngine.AbstractActionPrxList __ret;
		    {
			int szx = __is.readSize();
			__is.startSeq(szx, 2);
			__ret = new FlowEngine.AbstractActionPrxList(szx);
			for(int __ix = 0; __ix < szx; ++__ix)
			{
			    __ret.Add(FlowEngine.AbstractActionPrxHelper.__read(__is));
			    __is.checkSeq();
			    __is.endElement();
			}
			__is.endSeq(szx);
		    }
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public FlowEngine.AbstractActionPrx findAction(int id, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("findAction", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		try
		{
		    IceInternal.BasicStream __os = __out.ostr();
		    __os.writeInt(id);
		}
		catch(Ice.LocalException __ex)
		{
		    __out.abort(__ex);
		}
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    FlowEngine.AbstractActionPrx __ret;
		    __ret = FlowEngine.AbstractActionPrxHelper.__read(__is);
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public FlowEngine.IntMap getConnectionMap(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getConnectionMap", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    FlowEngine.IntMap __ret;
		    __ret = FlowEngine.IntMapHelper.read(__is);
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public FlowEngine.AbstractActionPrx getCurrentAction(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getCurrentAction", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    FlowEngine.AbstractActionPrx __ret;
		    __ret = FlowEngine.AbstractActionPrxHelper.__read(__is);
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getNextActions", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		try
		{
		    IceInternal.BasicStream __os = __out.ostr();
		    FlowEngine.AbstractActionPrxHelper.__write(__os, action);
		}
		catch(Ice.LocalException __ex)
		{
		    __out.abort(__ex);
		}
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    FlowEngine.AbstractActionPrxList __ret;
		    {
			int szx = __is.readSize();
			__is.startSeq(szx, 2);
			__ret = new FlowEngine.AbstractActionPrxList(szx);
			for(int __ix = 0; __ix < szx; ++__ix)
			{
			    __ret.Add(FlowEngine.AbstractActionPrxHelper.__read(__is));
			    __is.checkSeq();
			    __is.endElement();
			}
			__is.endSeq(szx);
		    }
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public FlowEngine.AbstractActionPrxList getNextActionsById(int id, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getNextActionsById", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		try
		{
		    IceInternal.BasicStream __os = __out.ostr();
		    __os.writeInt(id);
		}
		catch(Ice.LocalException __ex)
		{
		    __out.abort(__ex);
		}
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    FlowEngine.AbstractActionPrxList __ret;
		    {
			int szx = __is.readSize();
			__is.startSeq(szx, 2);
			__ret = new FlowEngine.AbstractActionPrxList(szx);
			for(int __ix = 0; __ix < szx; ++__ix)
			{
			    __ret.Add(FlowEngine.AbstractActionPrxHelper.__read(__is));
			    __is.checkSeq();
			    __is.endElement();
			}
			__is.endSeq(szx);
		    }
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public bool isActive(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("isActive", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    bool __ret;
		    __ret = __is.readBool();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void setEdge(int id0, int id1, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("setEdge", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		try
		{
		    IceInternal.BasicStream __os = __out.ostr();
		    __os.writeInt(id0);
		    __os.writeInt(id1);
		}
		catch(Ice.LocalException __ex)
		{
		    __out.abort(__ex);
		}
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public bool tempIterate(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("tempIterate", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    bool __ret;
		    __ret = __is.readBool();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}
    }

    public sealed class _ProcessFactoryDelM : Ice._ObjectDelM, _ProcessFactoryDel
    {
	public FlowEngine.ProcessPrx createProcess(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("createProcess", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    FlowEngine.ProcessPrx __ret;
		    __ret = FlowEngine.ProcessPrxHelper.__read(__is);
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}
    }
}

namespace FlowEngine
{
    public sealed class _AbstractActionDelD : Ice._ObjectDelD, _AbstractActionDel
    {
	public string describe(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "describe", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is AbstractAction)
		{
		    try
		    {
			return ((FlowEngine.AbstractAction)__servant).describe(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public bool done(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "done", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is AbstractAction)
		{
		    try
		    {
			return ((FlowEngine.AbstractAction)__servant).done(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public int getId(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getId", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is AbstractAction)
		{
		    try
		    {
			return ((FlowEngine.AbstractAction)__servant).getId(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void perform(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "perform", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is AbstractAction)
		{
		    try
		    {
			((FlowEngine.AbstractAction)__servant).perform(__current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void setId(int id, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "setId", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is AbstractAction)
		{
		    try
		    {
			((FlowEngine.AbstractAction)__servant).setId(id, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void setOptions(Global.KeyValueList options, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "setOptions", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is AbstractAction)
		{
		    try
		    {
			((FlowEngine.AbstractAction)__servant).setOptions(options, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}
    }

    public sealed class _AbstractActionFactoryDelD : Ice._ObjectDelD, _AbstractActionFactoryDel
    {
	public FlowEngine.AbstractActionPrx createAction(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "createAction", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is AbstractActionFactory)
		{
		    try
		    {
			return ((FlowEngine.AbstractActionFactory)__servant).createAction(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public string describe(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "describe", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is AbstractActionFactory)
		{
		    try
		    {
			return ((FlowEngine.AbstractActionFactory)__servant).describe(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}
    }

    public sealed class _ProcessDelD : Ice._ObjectDelD, _ProcessDel
    {
	public int addAction(FlowEngine.AbstractActionPrx action, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "addAction", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			return ((FlowEngine.Process)__servant).addAction(action, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void addActionWithId(FlowEngine.AbstractActionPrx action, int id, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "addActionWithId", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			((FlowEngine.Process)__servant).addActionWithId(action, id, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public FlowEngine.AbstractActionPrxList enumActions(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "enumActions", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			return ((FlowEngine.Process)__servant).enumActions(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public FlowEngine.AbstractActionPrxList enumStartActions(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "enumStartActions", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			return ((FlowEngine.Process)__servant).enumStartActions(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public FlowEngine.AbstractActionPrx findAction(int id, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "findAction", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			return ((FlowEngine.Process)__servant).findAction(id, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public FlowEngine.IntMap getConnectionMap(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getConnectionMap", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			return ((FlowEngine.Process)__servant).getConnectionMap(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public FlowEngine.AbstractActionPrx getCurrentAction(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getCurrentAction", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			return ((FlowEngine.Process)__servant).getCurrentAction(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getNextActions", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			return ((FlowEngine.Process)__servant).getNextActions(action, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public FlowEngine.AbstractActionPrxList getNextActionsById(int id, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getNextActionsById", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			return ((FlowEngine.Process)__servant).getNextActionsById(id, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public bool isActive(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "isActive", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			return ((FlowEngine.Process)__servant).isActive(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void setEdge(int id0, int id1, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "setEdge", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			((FlowEngine.Process)__servant).setEdge(id0, id1, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public bool tempIterate(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "tempIterate", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Process)
		{
		    try
		    {
			return ((FlowEngine.Process)__servant).tempIterate(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}
    }

    public sealed class _ProcessFactoryDelD : Ice._ObjectDelD, _ProcessFactoryDel
    {
	public FlowEngine.ProcessPrx createProcess(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "createProcess", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is ProcessFactory)
		{
		    try
		    {
			return ((FlowEngine.ProcessFactory)__servant).createProcess(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}
    }
}

namespace FlowEngine
{
    public abstract class _AbstractActionDisp : Ice.ObjectImpl, AbstractAction
    {
	#region Slice operations

	public string describe()
	{
	    return describe(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract string describe(Ice.Current __current);

	public void setOptions(Global.KeyValueList options)
	{
	    setOptions(options, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void setOptions(Global.KeyValueList options, Ice.Current __current);

	public int getId()
	{
	    return getId(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract int getId(Ice.Current __current);

	public void setId(int id)
	{
	    setId(id, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void setId(int id, Ice.Current __current);

	public void perform()
	{
	    perform(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void perform(Ice.Current __current);

	public bool done()
	{
	    return done(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract bool done(Ice.Current __current);

	#endregion

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::FlowEngine::AbstractAction",
	    "::Ice::Object"
	};

	public override bool ice_isA(string s)
	{
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[0];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[0];
	}

	public static new string ice_staticId()
	{
	    return __ids[0];
	}

	#endregion

	#region Operation dispatch

	public static IceInternal.DispatchStatus ___describe(AbstractAction __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    string __ret = __obj.describe(__current);
	    __os.writeString(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___setOptions(AbstractAction __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    Global.KeyValueList options;
	    {
		int szx = __is.readSize();
		__is.startSeq(szx, 2);
		options = new Global.KeyValueList(szx);
		for(int __ix = 0; __ix < options.Count; ++__ix)
		{
		    options[__ix].__read(__is);
		    __is.checkSeq();
		    __is.endElement();
		}
		__is.endSeq(szx);
	    }
	    __obj.setOptions(options, __current);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___getId(AbstractAction __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    int __ret = __obj.getId(__current);
	    __os.writeInt(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___setId(AbstractAction __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    int id;
	    id = __is.readInt();
	    __obj.setId(id, __current);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___perform(AbstractAction __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    __obj.perform(__current);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___done(AbstractAction __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    bool __ret = __obj.done(__current);
	    __os.writeBool(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	private static string[] __all =
	{
	    "describe",
	    "done",
	    "getId",
	    "ice_id",
	    "ice_ids",
	    "ice_isA",
	    "ice_ping",
	    "perform",
	    "setId",
	    "setOptions"
	};

	public override IceInternal.DispatchStatus __dispatch(IceInternal.Incoming __in, Ice.Current __current)
	{
	    int pos;
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation);
	    }
	    else
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation, _System.Collections.Comparer.DefaultInvariant);
	    }
	    if(pos < 0)
	    {
		return IceInternal.DispatchStatus.DispatchOperationNotExist;
	    }

	    switch(pos)
	    {
		case 0:
		{
		    return ___describe(this, __in, __current);
		}
		case 1:
		{
		    return ___done(this, __in, __current);
		}
		case 2:
		{
		    return ___getId(this, __in, __current);
		}
		case 3:
		{
		    return ___ice_id(this, __in, __current);
		}
		case 4:
		{
		    return ___ice_ids(this, __in, __current);
		}
		case 5:
		{
		    return ___ice_isA(this, __in, __current);
		}
		case 6:
		{
		    return ___ice_ping(this, __in, __current);
		}
		case 7:
		{
		    return ___perform(this, __in, __current);
		}
		case 8:
		{
		    return ___setId(this, __in, __current);
		}
		case 9:
		{
		    return ___setOptions(this, __in, __current);
		}
	    }

	    _System.Diagnostics.Debug.Assert(false);
	    return IceInternal.DispatchStatus.DispatchOperationNotExist;
	}

	#endregion
    }

    public abstract class _AbstractActionFactoryDisp : Ice.ObjectImpl, AbstractActionFactory
    {
	#region Slice operations

	public FlowEngine.AbstractActionPrx createAction()
	{
	    return createAction(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract FlowEngine.AbstractActionPrx createAction(Ice.Current __current);

	public string describe()
	{
	    return describe(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract string describe(Ice.Current __current);

	#endregion

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::FlowEngine::AbstractActionFactory",
	    "::Ice::Object"
	};

	public override bool ice_isA(string s)
	{
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[0];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[0];
	}

	public static new string ice_staticId()
	{
	    return __ids[0];
	}

	#endregion

	#region Operation dispatch

	public static IceInternal.DispatchStatus ___createAction(AbstractActionFactory __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    FlowEngine.AbstractActionPrx __ret = __obj.createAction(__current);
	    FlowEngine.AbstractActionPrxHelper.__write(__os, __ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___describe(AbstractActionFactory __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    string __ret = __obj.describe(__current);
	    __os.writeString(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	private static string[] __all =
	{
	    "createAction",
	    "describe",
	    "ice_id",
	    "ice_ids",
	    "ice_isA",
	    "ice_ping"
	};

	public override IceInternal.DispatchStatus __dispatch(IceInternal.Incoming __in, Ice.Current __current)
	{
	    int pos;
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation);
	    }
	    else
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation, _System.Collections.Comparer.DefaultInvariant);
	    }
	    if(pos < 0)
	    {
		return IceInternal.DispatchStatus.DispatchOperationNotExist;
	    }

	    switch(pos)
	    {
		case 0:
		{
		    return ___createAction(this, __in, __current);
		}
		case 1:
		{
		    return ___describe(this, __in, __current);
		}
		case 2:
		{
		    return ___ice_id(this, __in, __current);
		}
		case 3:
		{
		    return ___ice_ids(this, __in, __current);
		}
		case 4:
		{
		    return ___ice_isA(this, __in, __current);
		}
		case 5:
		{
		    return ___ice_ping(this, __in, __current);
		}
	    }

	    _System.Diagnostics.Debug.Assert(false);
	    return IceInternal.DispatchStatus.DispatchOperationNotExist;
	}

	#endregion
    }

    public abstract class _ProcessDisp : Ice.ObjectImpl, Process
    {
	#region Slice operations

	public FlowEngine.AbstractActionPrxList enumActions()
	{
	    return enumActions(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract FlowEngine.AbstractActionPrxList enumActions(Ice.Current __current);

	public FlowEngine.AbstractActionPrxList enumStartActions()
	{
	    return enumStartActions(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract FlowEngine.AbstractActionPrxList enumStartActions(Ice.Current __current);

	public FlowEngine.AbstractActionPrx getCurrentAction()
	{
	    return getCurrentAction(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract FlowEngine.AbstractActionPrx getCurrentAction(Ice.Current __current);

	public FlowEngine.AbstractActionPrx findAction(int id)
	{
	    return findAction(id, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract FlowEngine.AbstractActionPrx findAction(int id, Ice.Current __current);

	public FlowEngine.IntMap getConnectionMap()
	{
	    return getConnectionMap(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract FlowEngine.IntMap getConnectionMap(Ice.Current __current);

	public int addAction(FlowEngine.AbstractActionPrx action)
	{
	    return addAction(action, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract int addAction(FlowEngine.AbstractActionPrx action, Ice.Current __current);

	public void addActionWithId(FlowEngine.AbstractActionPrx action, int id)
	{
	    addActionWithId(action, id, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void addActionWithId(FlowEngine.AbstractActionPrx action, int id, Ice.Current __current);

	public bool isActive()
	{
	    return isActive(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract bool isActive(Ice.Current __current);

	public void setEdge(int id0, int id1)
	{
	    setEdge(id0, id1, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void setEdge(int id0, int id1, Ice.Current __current);

	public FlowEngine.AbstractActionPrxList getNextActionsById(int id)
	{
	    return getNextActionsById(id, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract FlowEngine.AbstractActionPrxList getNextActionsById(int id, Ice.Current __current);

	public FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action)
	{
	    return getNextActions(action, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract FlowEngine.AbstractActionPrxList getNextActions(FlowEngine.AbstractActionPrx action, Ice.Current __current);

	public bool tempIterate()
	{
	    return tempIterate(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract bool tempIterate(Ice.Current __current);

	#endregion

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::FlowEngine::Process",
	    "::Ice::Object"
	};

	public override bool ice_isA(string s)
	{
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[0];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[0];
	}

	public static new string ice_staticId()
	{
	    return __ids[0];
	}

	#endregion

	#region Operation dispatch

	public static IceInternal.DispatchStatus ___enumActions(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    FlowEngine.AbstractActionPrxList __ret = __obj.enumActions(__current);
	    if(__ret == null)
	    {
		__os.writeSize(0);
	    }
	    else
	    {
		__os.writeSize(__ret.Count);
		for(int __ix = 0; __ix < __ret.Count; ++__ix)
		{
		    FlowEngine.AbstractActionPrxHelper.__write(__os, __ret[__ix]);
		}
	    }
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___enumStartActions(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    FlowEngine.AbstractActionPrxList __ret = __obj.enumStartActions(__current);
	    if(__ret == null)
	    {
		__os.writeSize(0);
	    }
	    else
	    {
		__os.writeSize(__ret.Count);
		for(int __ix = 0; __ix < __ret.Count; ++__ix)
		{
		    FlowEngine.AbstractActionPrxHelper.__write(__os, __ret[__ix]);
		}
	    }
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___getCurrentAction(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    FlowEngine.AbstractActionPrx __ret = __obj.getCurrentAction(__current);
	    FlowEngine.AbstractActionPrxHelper.__write(__os, __ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___findAction(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    int id;
	    id = __is.readInt();
	    FlowEngine.AbstractActionPrx __ret = __obj.findAction(id, __current);
	    FlowEngine.AbstractActionPrxHelper.__write(__os, __ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___getConnectionMap(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    FlowEngine.IntMap __ret = __obj.getConnectionMap(__current);
	    FlowEngine.IntMapHelper.write(__os, __ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___addAction(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    FlowEngine.AbstractActionPrx action;
	    action = FlowEngine.AbstractActionPrxHelper.__read(__is);
	    int __ret = __obj.addAction(action, __current);
	    __os.writeInt(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___addActionWithId(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    FlowEngine.AbstractActionPrx action;
	    action = FlowEngine.AbstractActionPrxHelper.__read(__is);
	    int id;
	    id = __is.readInt();
	    __obj.addActionWithId(action, id, __current);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___isActive(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    bool __ret = __obj.isActive(__current);
	    __os.writeBool(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___setEdge(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    int id0;
	    id0 = __is.readInt();
	    int id1;
	    id1 = __is.readInt();
	    __obj.setEdge(id0, id1, __current);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___getNextActionsById(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    int id;
	    id = __is.readInt();
	    FlowEngine.AbstractActionPrxList __ret = __obj.getNextActionsById(id, __current);
	    if(__ret == null)
	    {
		__os.writeSize(0);
	    }
	    else
	    {
		__os.writeSize(__ret.Count);
		for(int __ix = 0; __ix < __ret.Count; ++__ix)
		{
		    FlowEngine.AbstractActionPrxHelper.__write(__os, __ret[__ix]);
		}
	    }
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___getNextActions(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    FlowEngine.AbstractActionPrx action;
	    action = FlowEngine.AbstractActionPrxHelper.__read(__is);
	    FlowEngine.AbstractActionPrxList __ret = __obj.getNextActions(action, __current);
	    if(__ret == null)
	    {
		__os.writeSize(0);
	    }
	    else
	    {
		__os.writeSize(__ret.Count);
		for(int __ix = 0; __ix < __ret.Count; ++__ix)
		{
		    FlowEngine.AbstractActionPrxHelper.__write(__os, __ret[__ix]);
		}
	    }
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___tempIterate(Process __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    bool __ret = __obj.tempIterate(__current);
	    __os.writeBool(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	private static string[] __all =
	{
	    "addAction",
	    "addActionWithId",
	    "enumActions",
	    "enumStartActions",
	    "findAction",
	    "getConnectionMap",
	    "getCurrentAction",
	    "getNextActions",
	    "getNextActionsById",
	    "ice_id",
	    "ice_ids",
	    "ice_isA",
	    "ice_ping",
	    "isActive",
	    "setEdge",
	    "tempIterate"
	};

	public override IceInternal.DispatchStatus __dispatch(IceInternal.Incoming __in, Ice.Current __current)
	{
	    int pos;
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation);
	    }
	    else
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation, _System.Collections.Comparer.DefaultInvariant);
	    }
	    if(pos < 0)
	    {
		return IceInternal.DispatchStatus.DispatchOperationNotExist;
	    }

	    switch(pos)
	    {
		case 0:
		{
		    return ___addAction(this, __in, __current);
		}
		case 1:
		{
		    return ___addActionWithId(this, __in, __current);
		}
		case 2:
		{
		    return ___enumActions(this, __in, __current);
		}
		case 3:
		{
		    return ___enumStartActions(this, __in, __current);
		}
		case 4:
		{
		    return ___findAction(this, __in, __current);
		}
		case 5:
		{
		    return ___getConnectionMap(this, __in, __current);
		}
		case 6:
		{
		    return ___getCurrentAction(this, __in, __current);
		}
		case 7:
		{
		    return ___getNextActions(this, __in, __current);
		}
		case 8:
		{
		    return ___getNextActionsById(this, __in, __current);
		}
		case 9:
		{
		    return ___ice_id(this, __in, __current);
		}
		case 10:
		{
		    return ___ice_ids(this, __in, __current);
		}
		case 11:
		{
		    return ___ice_isA(this, __in, __current);
		}
		case 12:
		{
		    return ___ice_ping(this, __in, __current);
		}
		case 13:
		{
		    return ___isActive(this, __in, __current);
		}
		case 14:
		{
		    return ___setEdge(this, __in, __current);
		}
		case 15:
		{
		    return ___tempIterate(this, __in, __current);
		}
	    }

	    _System.Diagnostics.Debug.Assert(false);
	    return IceInternal.DispatchStatus.DispatchOperationNotExist;
	}

	#endregion
    }

    public abstract class _ProcessFactoryDisp : Ice.ObjectImpl, ProcessFactory
    {
	#region Slice operations

	public FlowEngine.ProcessPrx createProcess()
	{
	    return createProcess(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract FlowEngine.ProcessPrx createProcess(Ice.Current __current);

	#endregion

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::FlowEngine::ProcessFactory",
	    "::Ice::Object"
	};

	public override bool ice_isA(string s)
	{
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[0];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[0];
	}

	public static new string ice_staticId()
	{
	    return __ids[0];
	}

	#endregion

	#region Operation dispatch

	public static IceInternal.DispatchStatus ___createProcess(ProcessFactory __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    FlowEngine.ProcessPrx __ret = __obj.createProcess(__current);
	    FlowEngine.ProcessPrxHelper.__write(__os, __ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	private static string[] __all =
	{
	    "createProcess",
	    "ice_id",
	    "ice_ids",
	    "ice_isA",
	    "ice_ping"
	};

	public override IceInternal.DispatchStatus __dispatch(IceInternal.Incoming __in, Ice.Current __current)
	{
	    int pos;
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation);
	    }
	    else
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation, _System.Collections.Comparer.DefaultInvariant);
	    }
	    if(pos < 0)
	    {
		return IceInternal.DispatchStatus.DispatchOperationNotExist;
	    }

	    switch(pos)
	    {
		case 0:
		{
		    return ___createProcess(this, __in, __current);
		}
		case 1:
		{
		    return ___ice_id(this, __in, __current);
		}
		case 2:
		{
		    return ___ice_ids(this, __in, __current);
		}
		case 3:
		{
		    return ___ice_isA(this, __in, __current);
		}
		case 4:
		{
		    return ___ice_ping(this, __in, __current);
		}
	    }

	    _System.Diagnostics.Debug.Assert(false);
	    return IceInternal.DispatchStatus.DispatchOperationNotExist;
	}

	#endregion
    }
}

namespace FlowEngine
{
    public abstract class AMI_AbstractAction_perform : IceInternal.OutgoingAsync
    {
	public abstract void ice_response();

	public void __invoke(Ice.ObjectPrx __prx, AMI_AbstractAction_perform __cb, Ice.Context __ctx)
	{
	    try
	    {
		__prepare(__prx, "perform", Ice.OperationMode.Normal, __ctx);
		__os.endWriteEncaps();
	    }
	    catch(Ice.LocalException __ex)
	    {
		__finished(__ex);
		return;
	    }
	    __send();
	}

	protected override void __response(bool __ok)
	{
	    try
	    {
		if(!__ok)
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(Ice.UserException)
		    {
			throw new Ice.UnknownUserException();
		    }
		}
	    }
	    catch(Ice.LocalException __ex)
	    {
		__finished(__ex);
		return;
	    }
	    ice_response();
	}
    }
}
