// **********************************************************************
//
// Copyright (c) 2003-2004 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.0.0
// Generated from file `global.ice'

using _System = System;
using _Microsoft = Microsoft;

namespace Global
{
    public class CIntList : _System.Collections.CollectionBase, _System.ICloneable
    {
	#region Constructors

	public CIntList()
	{
	}

	public CIntList(int capacity)
	{
	    InnerList.Capacity = capacity;
	}

	public CIntList(int[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region Array copy and conversion

	public void CopyTo(int[] __a)
	{
	    InnerList.CopyTo(__a);
	}

	public void CopyTo(int[] __a, int __i)
	{
	    InnerList.CopyTo(__a, __i);
	}

	public void CopyTo(int __i, int[] __a, int __ai, int __c)
	{
	    InnerList.CopyTo(__i, __a, __ai, __c);
	}

	public int[] ToArray()
	{
	    int[] __a = new int[InnerList.Count];
	    InnerList.CopyTo(__a, 0);
	    return __a;
	}

	#endregion

	#region AddRange members

	public void AddRange(CIntList __s)
	{
	    InnerList.AddRange(__s);
	}

	public void AddRange(int[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region ICollectionBase members

	public int Add(int value)
	{
	    return InnerList.Add(value);
	}

	public int IndexOf(int value)
	{
	    return InnerList.IndexOf(value);
	}

	public void Insert(int index, int value)
	{
	    InnerList.Insert(index, value);
	}

	public void Remove(int value)
	{
	    InnerList.Remove(value);
	}

	public bool Contains(int value)
	{
	    return InnerList.Contains(value);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region IList members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	#region Indexer

	public int this[int index]
	{
	    get
	    {
		return (int)InnerList[index];
	    }
	    set
	    {
		InnerList[index] = value;
	    }
	}

	#endregion

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    for(int i = 0; i < Count; ++i)
	    {
		hash = 5 * hash + InnerList[i].GetHashCode();
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is CIntList))
	    {
		return false;
	    }
	    if(Count != ((CIntList)other).Count)
	    {
		return false;
	    }
	    for(int __i = 0; __i < Count; ++__i)
	    {
		if(!((int)(InnerList[__i])).Equals(((CIntList)other)[__i]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(CIntList __lhs, CIntList __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(CIntList __lhs, CIntList __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(CIntList __lhs, CIntList __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion
    }

    public class CStringList : _System.Collections.CollectionBase, _System.ICloneable
    {
	#region Constructors

	public CStringList()
	{
	}

	public CStringList(int capacity)
	{
	    InnerList.Capacity = capacity;
	}

	public CStringList(string[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region Array copy and conversion

	public void CopyTo(string[] __a)
	{
	    InnerList.CopyTo(__a);
	}

	public void CopyTo(string[] __a, int __i)
	{
	    InnerList.CopyTo(__a, __i);
	}

	public void CopyTo(int __i, string[] __a, int __ai, int __c)
	{
	    InnerList.CopyTo(__i, __a, __ai, __c);
	}

	public string[] ToArray()
	{
	    string[] __a = new string[InnerList.Count];
	    InnerList.CopyTo(__a, 0);
	    return __a;
	}

	#endregion

	#region AddRange members

	public void AddRange(CStringList __s)
	{
	    InnerList.AddRange(__s);
	}

	public void AddRange(string[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region ICollectionBase members

	public int Add(string value)
	{
	    return InnerList.Add(value);
	}

	public int IndexOf(string value)
	{
	    return InnerList.IndexOf(value);
	}

	public void Insert(int index, string value)
	{
	    InnerList.Insert(index, value);
	}

	public void Remove(string value)
	{
	    InnerList.Remove(value);
	}

	public bool Contains(string value)
	{
	    return InnerList.Contains(value);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region IList members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	#region Indexer

	public string this[int index]
	{
	    get
	    {
		return (string)InnerList[index];
	    }
	    set
	    {
		InnerList[index] = value;
	    }
	}

	#endregion

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    for(int i = 0; i < Count; ++i)
	    {
		if((object)InnerList[i] != null)
		{
		    hash = 5 * hash + InnerList[i].GetHashCode();
		}
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is CStringList))
	    {
		return false;
	    }
	    if(Count != ((CStringList)other).Count)
	    {
		return false;
	    }
	    for(int __i = 0; __i < Count; ++__i)
	    {
		if(InnerList[__i] == null && ((CStringList)other)[__i] != null)
		{
		    return false;
		}
		if(!((string)(InnerList[__i])).Equals(((CStringList)other)[__i]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(CStringList __lhs, CStringList __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(CStringList __lhs, CStringList __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(CStringList __lhs, CStringList __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion
    }

    public class ByteSequence : _System.Collections.CollectionBase, _System.ICloneable
    {
	#region Constructors

	public ByteSequence()
	{
	}

	public ByteSequence(int capacity)
	{
	    InnerList.Capacity = capacity;
	}

	public ByteSequence(byte[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region Array copy and conversion

	public void CopyTo(byte[] __a)
	{
	    InnerList.CopyTo(__a);
	}

	public void CopyTo(byte[] __a, int __i)
	{
	    InnerList.CopyTo(__a, __i);
	}

	public void CopyTo(int __i, byte[] __a, int __ai, int __c)
	{
	    InnerList.CopyTo(__i, __a, __ai, __c);
	}

	public byte[] ToArray()
	{
	    byte[] __a = new byte[InnerList.Count];
	    InnerList.CopyTo(__a, 0);
	    return __a;
	}

	#endregion

	#region AddRange members

	public void AddRange(ByteSequence __s)
	{
	    InnerList.AddRange(__s);
	}

	public void AddRange(byte[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region ICollectionBase members

	public int Add(byte value)
	{
	    return InnerList.Add(value);
	}

	public int IndexOf(byte value)
	{
	    return InnerList.IndexOf(value);
	}

	public void Insert(int index, byte value)
	{
	    InnerList.Insert(index, value);
	}

	public void Remove(byte value)
	{
	    InnerList.Remove(value);
	}

	public bool Contains(byte value)
	{
	    return InnerList.Contains(value);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region IList members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	#region Indexer

	public byte this[int index]
	{
	    get
	    {
		return (byte)InnerList[index];
	    }
	    set
	    {
		InnerList[index] = value;
	    }
	}

	#endregion

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    for(int i = 0; i < Count; ++i)
	    {
		hash = 5 * hash + InnerList[i].GetHashCode();
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is ByteSequence))
	    {
		return false;
	    }
	    if(Count != ((ByteSequence)other).Count)
	    {
		return false;
	    }
	    for(int __i = 0; __i < Count; ++__i)
	    {
		if(!((byte)(InnerList[__i])).Equals(((ByteSequence)other)[__i]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(ByteSequence __lhs, ByteSequence __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(ByteSequence __lhs, ByteSequence __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(ByteSequence __lhs, ByteSequence __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion
    }

    public struct CDateTime
    {
	#region Slice data members

	public int nYear;

	public byte nMonth;

	public byte nDay;

	public byte nHour;

	public byte nMinute;

	public byte nSecond;

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int __h = 0;
	    __h = 5 * __h + nYear.GetHashCode();
	    __h = 5 * __h + nMonth.GetHashCode();
	    __h = 5 * __h + nDay.GetHashCode();
	    __h = 5 * __h + nHour.GetHashCode();
	    __h = 5 * __h + nMinute.GetHashCode();
	    __h = 5 * __h + nSecond.GetHashCode();
	    return __h;
	}

	public override bool Equals(object __other)
	{
	    if(object.ReferenceEquals(this, __other))
	    {
		return true;
	    }
	    if(!(__other is CDateTime))
	    {
		return false;
	    }
	    if(!(nYear.Equals(((CDateTime)__other).nYear)))
	    {
		return false;
	    }
	    if(!(nMonth.Equals(((CDateTime)__other).nMonth)))
	    {
		return false;
	    }
	    if(!(nDay.Equals(((CDateTime)__other).nDay)))
	    {
		return false;
	    }
	    if(!(nHour.Equals(((CDateTime)__other).nHour)))
	    {
		return false;
	    }
	    if(!(nMinute.Equals(((CDateTime)__other).nMinute)))
	    {
		return false;
	    }
	    if(!(nSecond.Equals(((CDateTime)__other).nSecond)))
	    {
		return false;
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(CDateTime __lhs, CDateTime __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(CDateTime __lhs, CDateTime __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(CDateTime __lhs, CDateTime __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion

	#region Marshalling support

	public void __write(IceInternal.BasicStream __os)
	{
	    __os.writeInt(nYear);
	    __os.writeByte(nMonth);
	    __os.writeByte(nDay);
	    __os.writeByte(nHour);
	    __os.writeByte(nMinute);
	    __os.writeByte(nSecond);
	}

	public void __read(IceInternal.BasicStream __is)
	{
	    nYear = __is.readInt();
	    nMonth = __is.readByte();
	    nDay = __is.readByte();
	    nHour = __is.readByte();
	    nMinute = __is.readByte();
	    nSecond = __is.readByte();
	}

	#endregion
    }

    public class CDateTimeList : _System.Collections.CollectionBase, _System.ICloneable
    {
	#region Constructors

	public CDateTimeList()
	{
	}

	public CDateTimeList(int capacity)
	{
	    InnerList.Capacity = capacity;
	}

	public CDateTimeList(Global.CDateTime[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region Array copy and conversion

	public void CopyTo(Global.CDateTime[] __a)
	{
	    InnerList.CopyTo(__a);
	}

	public void CopyTo(Global.CDateTime[] __a, int __i)
	{
	    InnerList.CopyTo(__a, __i);
	}

	public void CopyTo(int __i, Global.CDateTime[] __a, int __ai, int __c)
	{
	    InnerList.CopyTo(__i, __a, __ai, __c);
	}

	public Global.CDateTime[] ToArray()
	{
	    Global.CDateTime[] __a = new Global.CDateTime[InnerList.Count];
	    InnerList.CopyTo(__a, 0);
	    return __a;
	}

	#endregion

	#region AddRange members

	public void AddRange(CDateTimeList __s)
	{
	    InnerList.AddRange(__s);
	}

	public void AddRange(Global.CDateTime[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region ICollectionBase members

	public int Add(Global.CDateTime value)
	{
	    return InnerList.Add(value);
	}

	public int IndexOf(Global.CDateTime value)
	{
	    return InnerList.IndexOf(value);
	}

	public void Insert(int index, Global.CDateTime value)
	{
	    InnerList.Insert(index, value);
	}

	public void Remove(Global.CDateTime value)
	{
	    InnerList.Remove(value);
	}

	public bool Contains(Global.CDateTime value)
	{
	    return InnerList.Contains(value);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region IList members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	#region Indexer

	public Global.CDateTime this[int index]
	{
	    get
	    {
		return (Global.CDateTime)InnerList[index];
	    }
	    set
	    {
		InnerList[index] = value;
	    }
	}

	#endregion

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    for(int i = 0; i < Count; ++i)
	    {
		hash = 5 * hash + InnerList[i].GetHashCode();
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is CDateTimeList))
	    {
		return false;
	    }
	    if(Count != ((CDateTimeList)other).Count)
	    {
		return false;
	    }
	    for(int __i = 0; __i < Count; ++__i)
	    {
		if(!((Global.CDateTime)(InnerList[__i])).Equals(((CDateTimeList)other)[__i]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(CDateTimeList __lhs, CDateTimeList __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(CDateTimeList __lhs, CDateTimeList __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(CDateTimeList __lhs, CDateTimeList __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion
    }

    public enum WeekDays
    {
	Sunday,
	Monday,
	Tuesday,
	Wednesday,
	Thursday,
	Friday,
	Saturday
    }

    public class WeekDayList : _System.Collections.CollectionBase, _System.ICloneable
    {
	#region Constructors

	public WeekDayList()
	{
	}

	public WeekDayList(int capacity)
	{
	    InnerList.Capacity = capacity;
	}

	public WeekDayList(Global.WeekDays[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region Array copy and conversion

	public void CopyTo(Global.WeekDays[] __a)
	{
	    InnerList.CopyTo(__a);
	}

	public void CopyTo(Global.WeekDays[] __a, int __i)
	{
	    InnerList.CopyTo(__a, __i);
	}

	public void CopyTo(int __i, Global.WeekDays[] __a, int __ai, int __c)
	{
	    InnerList.CopyTo(__i, __a, __ai, __c);
	}

	public Global.WeekDays[] ToArray()
	{
	    Global.WeekDays[] __a = new Global.WeekDays[InnerList.Count];
	    InnerList.CopyTo(__a, 0);
	    return __a;
	}

	#endregion

	#region AddRange members

	public void AddRange(WeekDayList __s)
	{
	    InnerList.AddRange(__s);
	}

	public void AddRange(Global.WeekDays[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region ICollectionBase members

	public int Add(Global.WeekDays value)
	{
	    return InnerList.Add(value);
	}

	public int IndexOf(Global.WeekDays value)
	{
	    return InnerList.IndexOf(value);
	}

	public void Insert(int index, Global.WeekDays value)
	{
	    InnerList.Insert(index, value);
	}

	public void Remove(Global.WeekDays value)
	{
	    InnerList.Remove(value);
	}

	public bool Contains(Global.WeekDays value)
	{
	    return InnerList.Contains(value);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region IList members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	#region Indexer

	public Global.WeekDays this[int index]
	{
	    get
	    {
		return (Global.WeekDays)InnerList[index];
	    }
	    set
	    {
		InnerList[index] = value;
	    }
	}

	#endregion

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    for(int i = 0; i < Count; ++i)
	    {
		hash = 5 * hash + InnerList[i].GetHashCode();
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is WeekDayList))
	    {
		return false;
	    }
	    if(Count != ((WeekDayList)other).Count)
	    {
		return false;
	    }
	    for(int __i = 0; __i < Count; ++__i)
	    {
		if(!((Global.WeekDays)(InnerList[__i])).Equals(((WeekDayList)other)[__i]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(WeekDayList __lhs, WeekDayList __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(WeekDayList __lhs, WeekDayList __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(WeekDayList __lhs, WeekDayList __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion
    }

    public struct CDate
    {
	#region Slice data members

	public int nYear;

	public byte nMonth;

	public byte nDay;

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int __h = 0;
	    __h = 5 * __h + nYear.GetHashCode();
	    __h = 5 * __h + nMonth.GetHashCode();
	    __h = 5 * __h + nDay.GetHashCode();
	    return __h;
	}

	public override bool Equals(object __other)
	{
	    if(object.ReferenceEquals(this, __other))
	    {
		return true;
	    }
	    if(!(__other is CDate))
	    {
		return false;
	    }
	    if(!(nYear.Equals(((CDate)__other).nYear)))
	    {
		return false;
	    }
	    if(!(nMonth.Equals(((CDate)__other).nMonth)))
	    {
		return false;
	    }
	    if(!(nDay.Equals(((CDate)__other).nDay)))
	    {
		return false;
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(CDate __lhs, CDate __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(CDate __lhs, CDate __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(CDate __lhs, CDate __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion

	#region Marshalling support

	public void __write(IceInternal.BasicStream __os)
	{
	    __os.writeInt(nYear);
	    __os.writeByte(nMonth);
	    __os.writeByte(nDay);
	}

	public void __read(IceInternal.BasicStream __is)
	{
	    nYear = __is.readInt();
	    nMonth = __is.readByte();
	    nDay = __is.readByte();
	}

	#endregion
    }

    public struct CTime
    {
	#region Slice data members

	public byte nHour;

	public byte nMinute;

	public byte nSecond;

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int __h = 0;
	    __h = 5 * __h + nHour.GetHashCode();
	    __h = 5 * __h + nMinute.GetHashCode();
	    __h = 5 * __h + nSecond.GetHashCode();
	    return __h;
	}

	public override bool Equals(object __other)
	{
	    if(object.ReferenceEquals(this, __other))
	    {
		return true;
	    }
	    if(!(__other is CTime))
	    {
		return false;
	    }
	    if(!(nHour.Equals(((CTime)__other).nHour)))
	    {
		return false;
	    }
	    if(!(nMinute.Equals(((CTime)__other).nMinute)))
	    {
		return false;
	    }
	    if(!(nSecond.Equals(((CTime)__other).nSecond)))
	    {
		return false;
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(CTime __lhs, CTime __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(CTime __lhs, CTime __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(CTime __lhs, CTime __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion

	#region Marshalling support

	public void __write(IceInternal.BasicStream __os)
	{
	    __os.writeByte(nHour);
	    __os.writeByte(nMinute);
	    __os.writeByte(nSecond);
	}

	public void __read(IceInternal.BasicStream __is)
	{
	    nHour = __is.readByte();
	    nMinute = __is.readByte();
	    nSecond = __is.readByte();
	}

	#endregion
    }

    public class CTimeList : _System.Collections.CollectionBase, _System.ICloneable
    {
	#region Constructors

	public CTimeList()
	{
	}

	public CTimeList(int capacity)
	{
	    InnerList.Capacity = capacity;
	}

	public CTimeList(Global.CTime[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region Array copy and conversion

	public void CopyTo(Global.CTime[] __a)
	{
	    InnerList.CopyTo(__a);
	}

	public void CopyTo(Global.CTime[] __a, int __i)
	{
	    InnerList.CopyTo(__a, __i);
	}

	public void CopyTo(int __i, Global.CTime[] __a, int __ai, int __c)
	{
	    InnerList.CopyTo(__i, __a, __ai, __c);
	}

	public Global.CTime[] ToArray()
	{
	    Global.CTime[] __a = new Global.CTime[InnerList.Count];
	    InnerList.CopyTo(__a, 0);
	    return __a;
	}

	#endregion

	#region AddRange members

	public void AddRange(CTimeList __s)
	{
	    InnerList.AddRange(__s);
	}

	public void AddRange(Global.CTime[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region ICollectionBase members

	public int Add(Global.CTime value)
	{
	    return InnerList.Add(value);
	}

	public int IndexOf(Global.CTime value)
	{
	    return InnerList.IndexOf(value);
	}

	public void Insert(int index, Global.CTime value)
	{
	    InnerList.Insert(index, value);
	}

	public void Remove(Global.CTime value)
	{
	    InnerList.Remove(value);
	}

	public bool Contains(Global.CTime value)
	{
	    return InnerList.Contains(value);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region IList members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	#region Indexer

	public Global.CTime this[int index]
	{
	    get
	    {
		return (Global.CTime)InnerList[index];
	    }
	    set
	    {
		InnerList[index] = value;
	    }
	}

	#endregion

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    for(int i = 0; i < Count; ++i)
	    {
		hash = 5 * hash + InnerList[i].GetHashCode();
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is CTimeList))
	    {
		return false;
	    }
	    if(Count != ((CTimeList)other).Count)
	    {
		return false;
	    }
	    for(int __i = 0; __i < Count; ++__i)
	    {
		if(!((Global.CTime)(InnerList[__i])).Equals(((CTimeList)other)[__i]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(CTimeList __lhs, CTimeList __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(CTimeList __lhs, CTimeList __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(CTimeList __lhs, CTimeList __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion
    }

    public struct KeyValue
    {
	#region Slice data members

	public string key;

	public string value;

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int __h = 0;
	    if(key != null)
	    {
		__h = 5 * __h + key.GetHashCode();
	    }
	    if(value != null)
	    {
		__h = 5 * __h + value.GetHashCode();
	    }
	    return __h;
	}

	public override bool Equals(object __other)
	{
	    if(object.ReferenceEquals(this, __other))
	    {
		return true;
	    }
	    if(!(__other is KeyValue))
	    {
		return false;
	    }
	    if(key == null)
	    {
		if(((KeyValue)__other).key != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(key.Equals(((KeyValue)__other).key)))
		{
		    return false;
		}
	    }
	    if(value == null)
	    {
		if(((KeyValue)__other).value != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(value.Equals(((KeyValue)__other).value)))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(KeyValue __lhs, KeyValue __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(KeyValue __lhs, KeyValue __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(KeyValue __lhs, KeyValue __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion

	#region Marshalling support

	public void __write(IceInternal.BasicStream __os)
	{
	    __os.writeString(key);
	    __os.writeString(value);
	}

	public void __read(IceInternal.BasicStream __is)
	{
	    key = __is.readString();
	    value = __is.readString();
	}

	#endregion
    }

    public class KeyValueList : _System.Collections.CollectionBase, _System.ICloneable
    {
	#region Constructors

	public KeyValueList()
	{
	}

	public KeyValueList(int capacity)
	{
	    InnerList.Capacity = capacity;
	}

	public KeyValueList(Global.KeyValue[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region Array copy and conversion

	public void CopyTo(Global.KeyValue[] __a)
	{
	    InnerList.CopyTo(__a);
	}

	public void CopyTo(Global.KeyValue[] __a, int __i)
	{
	    InnerList.CopyTo(__a, __i);
	}

	public void CopyTo(int __i, Global.KeyValue[] __a, int __ai, int __c)
	{
	    InnerList.CopyTo(__i, __a, __ai, __c);
	}

	public Global.KeyValue[] ToArray()
	{
	    Global.KeyValue[] __a = new Global.KeyValue[InnerList.Count];
	    InnerList.CopyTo(__a, 0);
	    return __a;
	}

	#endregion

	#region AddRange members

	public void AddRange(KeyValueList __s)
	{
	    InnerList.AddRange(__s);
	}

	public void AddRange(Global.KeyValue[] __a)
	{
	    InnerList.AddRange(__a);
	}

	#endregion

	#region ICollectionBase members

	public int Add(Global.KeyValue value)
	{
	    return InnerList.Add(value);
	}

	public int IndexOf(Global.KeyValue value)
	{
	    return InnerList.IndexOf(value);
	}

	public void Insert(int index, Global.KeyValue value)
	{
	    InnerList.Insert(index, value);
	}

	public void Remove(Global.KeyValue value)
	{
	    InnerList.Remove(value);
	}

	public bool Contains(Global.KeyValue value)
	{
	    return InnerList.Contains(value);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region IList members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	#region Indexer

	public Global.KeyValue this[int index]
	{
	    get
	    {
		return (Global.KeyValue)InnerList[index];
	    }
	    set
	    {
		InnerList[index] = value;
	    }
	}

	#endregion

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    for(int i = 0; i < Count; ++i)
	    {
		hash = 5 * hash + InnerList[i].GetHashCode();
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is KeyValueList))
	    {
		return false;
	    }
	    if(Count != ((KeyValueList)other).Count)
	    {
		return false;
	    }
	    for(int __i = 0; __i < Count; ++__i)
	    {
		if(!((Global.KeyValue)(InnerList[__i])).Equals(((KeyValueList)other)[__i]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(KeyValueList __lhs, KeyValueList __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(KeyValueList __lhs, KeyValueList __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(KeyValueList __lhs, KeyValueList __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion
    }
}

namespace Global
{
    public sealed class CIntListHelper
    {
	public static void write(IceInternal.BasicStream __os, Global.CIntList __v)
	{
	    __os.writeIntSeq(__v.ToArray());
	}

	public static Global.CIntList read(IceInternal.BasicStream __is)
	{
	    Global.CIntList __v;
	    __v = new Global.CIntList(__is.readIntSeq());
	    return __v;
	}
    }

    public sealed class CStringListHelper
    {
	public static void write(IceInternal.BasicStream __os, Global.CStringList __v)
	{
	    __os.writeStringSeq(__v.ToArray());
	}

	public static Global.CStringList read(IceInternal.BasicStream __is)
	{
	    Global.CStringList __v;
	    __v = new Global.CStringList(__is.readStringSeq());
	    return __v;
	}
    }

    public sealed class ByteSequenceHelper
    {
	public static void write(IceInternal.BasicStream __os, Global.ByteSequence __v)
	{
	    __os.writeByteSeq(__v.ToArray());
	}

	public static Global.ByteSequence read(IceInternal.BasicStream __is)
	{
	    Global.ByteSequence __v;
	    __v = new Global.ByteSequence(__is.readByteSeq());
	    return __v;
	}
    }

    public sealed class CDateTimeListHelper
    {
	public static void write(IceInternal.BasicStream __os, Global.CDateTimeList __v)
	{
	    if(__v == null)
	    {
		__os.writeSize(0);
	    }
	    else
	    {
		__os.writeSize(__v.Count);
		for(int __ix = 0; __ix < __v.Count; ++__ix)
		{
		    __v[__ix].__write(__os);
		}
	    }
	}

	public static Global.CDateTimeList read(IceInternal.BasicStream __is)
	{
	    Global.CDateTimeList __v;
	    {
		int szx = __is.readSize();
		__is.startSeq(szx, 9);
		__v = new Global.CDateTimeList(szx);
		for(int __ix = 0; __ix < __v.Count; ++__ix)
		{
		    __v[__ix].__read(__is);
		}
		__is.endSeq(szx);
	    }
	    return __v;
	}
    }

    public sealed class WeekDayListHelper
    {
	public static void write(IceInternal.BasicStream __os, Global.WeekDayList __v)
	{
	    if(__v == null)
	    {
		__os.writeSize(0);
	    }
	    else
	    {
		__os.writeSize(__v.Count);
		for(int __ix = 0; __ix < __v.Count; ++__ix)
		{
		    __os.writeByte((byte)__v[__ix]);
		}
	    }
	}

	public static Global.WeekDayList read(IceInternal.BasicStream __is)
	{
	    Global.WeekDayList __v;
	    {
		int szx = __is.readSize();
		__is.startSeq(szx, 1);
		__v = new Global.WeekDayList(szx);
		for(int __ix = 0; __ix < szx; ++__ix)
		{
		    __v.Add((Global.WeekDays)__is.readByte());
		}
		__is.endSeq(szx);
	    }
	    return __v;
	}
    }

    public sealed class CTimeListHelper
    {
	public static void write(IceInternal.BasicStream __os, Global.CTimeList __v)
	{
	    if(__v == null)
	    {
		__os.writeSize(0);
	    }
	    else
	    {
		__os.writeSize(__v.Count);
		for(int __ix = 0; __ix < __v.Count; ++__ix)
		{
		    __v[__ix].__write(__os);
		}
	    }
	}

	public static Global.CTimeList read(IceInternal.BasicStream __is)
	{
	    Global.CTimeList __v;
	    {
		int szx = __is.readSize();
		__is.startSeq(szx, 3);
		__v = new Global.CTimeList(szx);
		for(int __ix = 0; __ix < __v.Count; ++__ix)
		{
		    __v[__ix].__read(__is);
		}
		__is.endSeq(szx);
	    }
	    return __v;
	}
    }

    public sealed class KeyValueListHelper
    {
	public static void write(IceInternal.BasicStream __os, Global.KeyValueList __v)
	{
	    if(__v == null)
	    {
		__os.writeSize(0);
	    }
	    else
	    {
		__os.writeSize(__v.Count);
		for(int __ix = 0; __ix < __v.Count; ++__ix)
		{
		    __v[__ix].__write(__os);
		}
	    }
	}

	public static Global.KeyValueList read(IceInternal.BasicStream __is)
	{
	    Global.KeyValueList __v;
	    {
		int szx = __is.readSize();
		__is.startSeq(szx, 2);
		__v = new Global.KeyValueList(szx);
		for(int __ix = 0; __ix < __v.Count; ++__ix)
		{
		    __v[__ix].__read(__is);
		    __is.checkSeq();
		    __is.endElement();
		}
		__is.endSeq(szx);
	    }
	    return __v;
	}
    }
}
