using System;
using AbstractActionImplementation;
using Global;
using System.Net.Sockets;
using System.IO;



namespace MessageAction
{
	public class MessageActionI : AbstractActionImplementationI
	{
		public MessageActionI()
		{
			m_nId   = 0;
			m_bDone = true;
		} // !AbstractActionTemplate()



		public override string describe(Ice.Current current)
		{
			return "Message action";
		} // !describe()
		

		
		public override void perform(Ice.Current current)
		{
			m_bDone = false;
				
			System.Console.WriteLine("MessageAction output here");
			
			sendMessage("stephan@honeydew.athome.de",
			            "stephan@honeydew.athome.de",
			            "Mein subject",
			            "Mein Text",
			            "honeydew.athome.de");

			m_bDone = true;
		} // !perform()
		
		
		
		private bool sendMessage(string from, string to, string subject, string message, string server)
		{
			string Data;
			byte[] szData;
			string CRLF = "\r\n";
			
			try
			{
				TcpClient SmtpServ = new TcpClient(server, 25);		
			
				// initialization
				NetworkStream NetStrm = SmtpServ.GetStream();
				StreamReader  RdStrm  = new StreamReader(SmtpServ.GetStream());
									
				// say hello to server and send response into log report
				Data = "HELLO server " + CRLF;				
				szData = System.Text.Encoding.ASCII.GetBytes(Data.ToCharArray());
				NetStrm.Write(szData,0,szData.Length);
				
				// send sender data
				Data = "MAIL FROM: " + "<" + from + ">" + CRLF;
				szData = System.Text.Encoding.ASCII.GetBytes(Data.ToCharArray());
				NetStrm.Write(szData,0,szData.Length);
		
				// send receiver data
				Data = "RCPT TO: " + "<" + to + ">" + CRLF;
				szData = System.Text.Encoding.ASCII.GetBytes(Data.ToCharArray());
				NetStrm.Write(szData,0,szData.Length);
		
				// send DATA
				Data = "DATA " + CRLF;
				szData = System.Text.Encoding.ASCII.GetBytes(Data.ToCharArray());
				NetStrm.Write(szData,0,szData.Length);				
		
				// send content data
				Data = "SUBJECT: " + subject + CRLF + message + CRLF + "." + CRLF;
				szData = System.Text.Encoding.ASCII.GetBytes(Data.ToCharArray());
				NetStrm.Write(szData,0,szData.Length);			
		
				// quit from server SMTP
				Data = "QUIT " + CRLF;
				szData = System.Text.Encoding.ASCII.GetBytes(Data.ToCharArray());
				NetStrm.Write(szData,0,szData.Length);			
		
				// close connection
				NetStrm.Close();
				RdStrm.Close();
			}
			catch (InvalidOperationException err)
			{
				System.Console.Error.WriteLine("Error sending message (1).");
				return false;
			}
			catch (System.Net.Sockets.SocketException ex)
			{
				System.Console.Error.WriteLine("Error sending message (2).");
				return false;
			}
			return true;
		}
	}
	
	
	
	
	
	public class MessageActionFactoryI : AbstractActionFactoryImplementationI
	{
		public override string describe(Ice.Current current)
		{
			return "Message action factory";
		} // !describe()
		
		public override FlowEngine.AbstractActionPrx createAction(Ice.Current current)
		{
			if (m_adapter == null)
			{	
				/** 
				 * @todo add debugging info
				 */
				return null;
			}
			
			m_enumerator++;			
			MessageActionI obj = new MessageActionI();
			Ice.ObjectPrx prx  = m_adapter.add(obj, Ice.Util.stringToIdentity("messageaction" + m_enumerator.ToString("D8")));
        	return FlowEngine.AbstractActionPrxHelper.uncheckedCast(prx);
		} // !createAction()
	}
}
