using System;
using AbstractActionImplementation;



namespace StateActions
{
	public class StartActionI : AbstractActionImplementationI
	{
		public override string describe(Ice.Current current)
		{
			return "StartAction";
		} // !describe()		
		
		
		
		public override void perform(Ice.Current current)
		{
			m_bDone = false;
				
			System.Console.WriteLine("Performing start action");

			m_bDone = true;
		} // !perform()
	}
	
	
	
	
	public class EndActionI : AbstractActionImplementationI
	{
		public override string describe(Ice.Current current)
		{
			return "EndAction";
		} // !describe()		
		
		
		
		public override void perform(Ice.Current current)
		{
			m_bDone = false;
				
			System.Console.WriteLine("Performing end action");

			m_bDone = true;
		} // !perform()
	}
	
	
	
	
	public class DecisionActionI : AbstractActionImplementationI
	{
		public override string describe(Ice.Current current)
		{
			return "DecisionAction";
		} // !describe()		
		
		
		
		public override void perform(Ice.Current current)
		{
			m_bDone = false;
				
			System.Console.WriteLine("Performing decision action");

			m_bDone = true;
		} // !perform()
	}
	
	
	
	
	public class StartActionFactoryI : AbstractActionFactoryImplementationI
	{
		public override string describe(Ice.Current current)
		{
			return "start action factory";
		} // !describe()
		
		
		
		public override FlowEngine.AbstractActionPrx createAction(Ice.Current current)
		{
			if (m_adapter == null)
			{	
				/** 
				 * @todo add debugging info
				 */
				return null;
			}
			
			m_enumerator++;			
			StartActionI obj  = new StartActionI();
			Ice.ObjectPrx prx = m_adapter.add(obj, Ice.Util.stringToIdentity("startaction" + m_enumerator.ToString("D8")));
        	return FlowEngine.AbstractActionPrxHelper.uncheckedCast(prx);
		} // !createAction()
	}
	
	
	
	
	
	
	
	public class EndActionFactoryI : AbstractActionFactoryImplementationI
	{
		public override string describe(Ice.Current current)
		{
			return "end action factory";
		} // !describe()
		
		
		
		public override FlowEngine.AbstractActionPrx createAction(Ice.Current current)
		{
			if (m_adapter == null)
			{	
				/** 
				 * @todo add debugging info
				 */
				return null;
			}
			
			m_enumerator++;			
			EndActionI obj    = new EndActionI();
			Ice.ObjectPrx prx = m_adapter.add(obj, Ice.Util.stringToIdentity("endaction" + m_enumerator.ToString("D8")));
        	return FlowEngine.AbstractActionPrxHelper.uncheckedCast(prx);
		} // !createAction()
	}
	
	
	
	
	
	
	
	public class DecisionActionFactoryI : AbstractActionFactoryImplementationI
	{
		public override string describe(Ice.Current current)
		{
			return "decision action factory";
		} // !describe()
		
		
		
		public override FlowEngine.AbstractActionPrx createAction(Ice.Current current)
		{
			if (m_adapter == null)
			{	
				/** 
				 * @todo add debugging info
				 */
				return null;
			}
			
			m_enumerator++;			
			DecisionActionI obj = new DecisionActionI();
			Ice.ObjectPrx prx   = m_adapter.add(obj, Ice.Util.stringToIdentity("decisionaction" + m_enumerator.ToString("D8")));
        	return FlowEngine.AbstractActionPrxHelper.uncheckedCast(prx);
		} // !createAction()
	}	
}


