using System;
using AbstractActionImplementation;



namespace WaitForFileAction
{
	public class WaitForFileActionI : AbstractActionImplementationI
	{
		public override string describe(Ice.Current current)
		{
			return "waitforfile action";
		} // !describe()		
		
		
		
		public override void perform(Ice.Current current)
		{
			m_bDone = false;
		
			// work around
			Global.KeyValue kv;
	        kv.key   = "FilePath";
	        kv.value = "c:\\temp\\thisfileshouldexist.txt";	        
	        m_rgOptions.add(kv);	        
			
			if (!m_rgOptions.hasKey("FilePath"))
			{
				System.Console.Error.WriteLine("Do not have the FilePath option set. Aborting.");
				/**
				 * @todo this is a negative result, react somehow!
				 */
				m_bDone = true;
				return;
			}
			
			string szFilePath = m_rgOptions.getValue("FilePath");
			
			while (!System.IO.File.Exists(szFilePath))
			{								
				System.Threading.Thread.Sleep(200);
			}			

			m_bDone = true;
		} // !perform()
	}
	
	
	
	
	
	
	public class WaitForFileActionFactoryI : AbstractActionFactoryImplementationI
	{
		public override string describe(Ice.Current current)
		{
			return "waitforfile action factory";
		} // !describe()
		
		
		
		public override FlowEngine.AbstractActionPrx createAction(Ice.Current current)
		{
			if (m_adapter == null)
			{	
				/** 
				 * @todo add debugging info
				 */
				return null;
			}
			
			m_enumerator++;			
			WaitForFileActionI obj = new WaitForFileActionI();
			Ice.ObjectPrx prx  = m_adapter.add(obj, Ice.Util.stringToIdentity("waitforfileaction" + m_enumerator.ToString("D8")));
        	return FlowEngine.AbstractActionPrxHelper.uncheckedCast(prx);
		} // !createAction()	
	}
}
